package abc.meta.ast;

import polyglot.ext.jl.ast.Node_c;
import polyglot.util.Position;

/**
 * Holds the meta level of an aspect.
 *
 * @author Eric Bodden
 */
public class MetaTag_c extends Node_c implements MetaTag {

    protected int level;

    /**
     * Constructs a new meta tag AST node.
     * @param metaLevel the meta level
     * @param pos the source code position
     */
    public MetaTag_c(int metaLevel, Position pos) {
        super(pos);
        level = metaLevel;
    }

    
    /**
     * {@inheritDoc}
     */
    public int getMetaLevel() {
        return level;
    }

}
