package abc.meta.ast;

import java.util.List;
import java.util.Map;

import abc.aspectj.visit.AspectInfoHarvester;
import abc.meta.weaving.aspectinfo.PointcutRef;
import abc.weaving.aspectinfo.Pointcut;

import polyglot.ast.Receiver;
import polyglot.util.Position;

/**
 * Custom implementation of named pointcuts returning a custom aspect info.
 *
 * @author Eric Bodden
 */
public class PCName_c extends abc.aspectj.ast.PCName_c {

    /**
     * @see abc.aspectj.ast.PCName_c#PCName_c(Position, Receiver, String, List)
     */
    public PCName_c(Position pos, Receiver target, String name, List args) {
        super(pos, target, name, args);
    }
    
    /**
     * Here we just return our own aspect info instead of the default one. 
     */
    public Pointcut makeAIPointcut() {
        Object pcd_key = mi; //Find the pointcut using the method instance as key
        Map decl_map = AspectInfoHarvester.pointcutDeclarationMap();
        List args = AspectInfoHarvester.convertArgPatterns(this.args);
        return new PointcutRef(pcd_key, decl_map, args, position(),target != null);
    }

}
