package abc.meta.types;

import polyglot.frontend.Source;
import polyglot.types.LazyClassInitializer;
import polyglot.types.TypeSystem;
import abc.meta.ast.MetaNodeFactory;

/**
 * Adds a meta level to the aspect type.
 * This is used to recover the meta level during matching (matching is based on types).
 * @author Eric Bodden
 */
public class AspectType_c extends abc.aspectj.types.AspectType_c implements AspectType {
	
	/** The meta level of this aspect. */
    protected int metaLevel = MetaNodeFactory.DEFAULT_ASPECT_LEVEL;

	/**
	 * @see abc.aspectj.types.AspectType_c#AspectType_c(TypeSystem, LazyClassInitializer, Source, int)
	 */
	public AspectType_c(TypeSystem ts, LazyClassInitializer init, Source fromSource, int perKind) {
		super(ts, init, fromSource, perKind);
	}
	
	/**
	 * {@inheritDoc}
	 */
	public void setMetaLevel(int level) {
		metaLevel = level; 
	}
    

	/**
	 * {@inheritDoc}
	 */
	public int getMetaLevel() {
		return metaLevel;
	}
	

}
