package abc.meta.weaving.aspectinfo;

import polyglot.util.Position;
import abc.weaving.aspectinfo.AbcClass;
import abc.weaving.aspectinfo.Per;

/**
 * Extended aspect info for aspect declarations, holding the meta level.
 * This is used for type checking, which we have to perform during weaving
 * because only at that time pointcuts are properly inlined, which is necessary for our checks.
 *
 * @author Eric Bodden
 */
public class Aspect extends abc.weaving.aspectinfo.Aspect {

    /** The meta level. */
    protected int metaLevel;
    
    /**
     * @param metaLevel the meta level
     * @see abc.weaving.aspectinfo.Aspect#Aspect(AbcClass, Per, Position)
     */
    public Aspect(AbcClass cl, Per per, int metaLevel, Position pos) {
        super(cl, per, pos);
        this.metaLevel = metaLevel;
    }

    /**
     * @return the metaLevel
     */
    public int getMetaLevel() {
        return metaLevel;
    }

}
